---
title: WebGL2RenderingContext.compressedTexSubImage3D()
slug: Web/API/WebGL2RenderingContext/compressedTexSubImage3D
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGL2RenderingContext.compressedTexSubImage3D()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API </a>specifies a three-dimensional sub-rectangle for a texture image in a compressed format.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">// read from the buffer bound to gl.P<code>IXEL_UNPACK_BUFFER</code>
void gl.compressedTexSubImage3D(target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, offset);

void gl.compressedTexSubImage3D(target, level, xoffset, yoffset, zoffset, width, height, depth, format, ArrayBufferView srcData, optional srcOffset, optional srcLengthOverride);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>target</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the binding point (target) of the active texture. Possible values:
 <ul>
  <li><code>gl.TEXTURE_3D</code>: A three-dimensional texture.</li>
  <li><code>gl.TEXTURE_2D_ARRAY</code>: A two-dimensional array texture.</li>
 </ul>
 </dd>
 <dt><code>level</code></dt>
 <dd>A {{domxref("GLint")}} specifying the level of detail. Level 0 is the base image level and level <em>n</em> is the <em>n</em>th mipmap reduction level.</dd>
 <dt><code>xoffset</code></dt>
 <dd>A {{domxref("GLint")}} specifying the x offset within the compressed texture image.</dd>
 <dt><code>yoffset</code></dt>
 <dd>A {{domxref("GLint")}} specifying the y offset within the compressed texture image.</dd>
 <dt><code>zoffset</code></dt>
 <dd>A {{domxref("GLint")}} specifying the z offset within the compressed texture image.</dd>
 <dt><code>width</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the width of the texture.</dd>
 <dt><code>height</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the height of the texture.</dd>
 <dt><code>depth</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the depth of the texture.</dd>
 <dt><code>format</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the compressed image format. Possible values:
 <ul>
  <li><code>gl.COMPRESSED_R11_EAC</code></li>
  <li><code>gl.COMPRESSED_SIGNED_R11_EAC</code></li>
  <li><code>gl.COMPRESSED_RG11_EAC</code></li>
  <li><code>gl.COMPRESSED_SIGNED_RG11_EAC</code></li>
  <li><code>gl.COMPRESSED_RGB8_ETC2</code></li>
  <li><code>gl.COMPRESSED_RGBA8_ETC2_EAC</code></li>
  <li><code>gl.COMPRESSED_SRGB8_ETC2</code></li>
  <li><code>gl.COMPRESSED_SRGB8_ALPHA8_ETC2_EAC</code></li>
  <li><code>gl.COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2</code></li>
  <li><code>gl.COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2</code></li>
 </ul>
 </dd>
 <dt><code>imageSize</code></dt>
 <dd>A {{domxref("GLint")}} specifying the number of bytes to read from the buffer bound to <code>gl.PIXEL_UNPACK_BUFFER</code>.</dd>
 <dt><code>offset</code></dt>
 <dd>A {{domxref("GLint")}} specifying the offset in bytes from which to read from the buffer bound to <code>gl.PIXEL_UNPACK_BUFFER</code>.</dd>
 <dt><code>srcData</code></dt>
 <dd>An {{domxref("ArrayBufferView")}} that be used as a data store for the compressed image data in memory.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.compressedTexSubImage3D(gl.TEXTURE_3D, 0, 0, 0, 512, 512, 512, gl.COMPRESSED_R11_EAC, textureData);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.6", "compressedTexSubImage3D")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glCompressedTexSubImage3D.xhtml", "glCompressedTexSubImage3D")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 3.0 API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGL2RenderingContext.compressedTexSubImage3D")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.compressedTexSubImage2D()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.compressedTexImage3D()")}}</li>
</ul>
